<template>
  <div id="app">
    <Header :user="user" style="grid-row: 1"/>
    <div class="content">
      <router-view :user="user" :key="$route.fullPath"/>
    </div>
  </div>
</template>

<style>
html, body {
  margin: 0;
  height: 100%;
}

#app {
  font-family: 'Roboto', Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  display: grid;
  grid-template-rows: 72px 1fr;
  grid-template-columns: 1fr;
  height: 100%;
  background: rgb(39,46,54);
  color: rgb(126, 104, 189)
}

.content {
  overflow-y: scroll;
  overflow-x: hidden;
}

.content > * {
  background: linear-gradient(0deg, rgba(39,46,54,1) 0%, rgba(0,0,0,1) 300px, rgba(39,46,54,1) 100%);
}

.box {
  border-radius: 20px;
  border: 2px solid black;
  padding: 20px;
  background-color: #0f0f0f;
}

h1, h2, h3, h4, h5, h6 {
  margin: 8px 0;
  /*font-family: 'Montserrat', 'Roboto Thin', Arial, sans-serif;*/
  font-family: 'Open Sans Condensed', 'Roboto Thin', Arial, sans-serif;
}

a {
  text-decoration: none;
  color: unset;
}

a:visited {
  color: unset;
}

hr {
  display: block;
  height: 1px;
  border: 0;
  border-top: 1px solid #ccc;
  margin: 1em 0;
  padding: 0;
}

span {
  color: white;
}

* {
  box-sizing: border-box;
}

input[type=text], input[type=password], button, textarea {
  background-color: #424242;
  color: white;
  border: 1px solid hsla(0,0%,100%,.7);
  border-radius: 4px;
  font-family: 'Roboto', Helvetica, Arial, sans-serif;
  font-size: 12pt;
  padding-left: 8px;
  padding-right: 8px;
  resize: none;
}
</style>

<script>
import Header from './components/Header'
import axios from 'axios'
import gravatar from 'gravatar'
export default {
  components: { Header },
  data() {
    return {
      user: null,
    }
  },
  methods: {
    onLoggedIn(token) {
      localStorage.setItem('access_token', token);
      this.fetchUserData();
    },
    onLoggedOut() {
      localStorage.removeItem('access_token');
      this.user = null;
    },
    fetchUserData() {
      axios.get(`${this.$hostname}/api/user/`).then((response) => {
        this.user = response.data;
        this.user.isAdmin = function () {
          return this.username === 'admin';
        }
        this.user.gravatar = gravatar.url(this.user.email, {s: '400'}, false);
      }).catch((error) => {
        console.error(error);
        this.onLoggedOut()
      })
    }
  },
  created () {
    this.$root.$on('loggedIn', this.onLoggedIn);
    this.$root.$on('loggedOut', this.onLoggedOut);
    axios.interceptors.request.use(function (config) {
      const token = localStorage.getItem('access_token');
      if (!!token) {
        config.headers.common['Authorization'] = `Bearer ${token}`;
      }
      return config;
    }, function (error) {
      return Promise.reject(error);
    })
    const token = localStorage.getItem('access_token');
    if (!!token) {
      this.fetchUserData();
    }
  }
}
</script>
